Wednesday, October 9, 2019

Leetcode 1088: Confusing Number II

https://leetcode.com › problems › confusing-number-ii

We can rotate digits by 180 degrees to form new digits. When 0, 1, 6, 8, 9 are rotated 180 degrees, they become 0, 1, 9, 8, 6 respectively. When 2, 3, 4, 5 and 7 are rotated 180 degrees, they become invalid.

A confusing number is a number that when rotated 180 degrees becomes a different number with each digit valid.(Note that the rotated number can be greater than the original number.)

Given a positive integer N, return the number of confusing numbers between 1 and N inclusive.



Example 1:

Input: 20
Output: 6
Explanation:
The confusing numbers are [6,9,10,16,18,19].
6 converts to 9.
9 converts to 6.
10 converts to 01 which is just 1.
16 converts to 91.
18 converts to 81.
19 converts to 61.
Example 2:

Input: 100
Output: 19
Explanation:
The confusing numbers are [6,9,10,16,18,19,60,61,66,68,80,81,86,89,90,91,98,99,100].


Note:

1 <= N <= 10^9


Notes:

The N to this question can be very large, so checking one by one is not a good choice.

As indicated by the question itself, only 0, 1, 6, 8, and 9 are valid numbers. So we just need to check the numbers composed by them.

Since we will compare digits at different positions, so string can be a good choice for easier coding than integer.

Now the question becomes a typical backtracking one: we will try all the possible combinations, then check the qualification. If valid, count +1.

See the code below:

  1. #include <iostream>
  2. #include <vector>
  3. #include <string>
  4. #include <algorithm>
  5.  
  6. using namespace std;
  7.  
  8. int findAllConfNums(int n);
  9.  
  10. void dfs(string t, string &s, string &nums, int &res);
  11.  
  12. int main() {
  13. int n = 100;
  14. int num = findAllConfNums(n);
  15. cout<<num;
  16. return 0;
  17. }
  18.  
  19. int findAllConfNums(int n) {
  20. int res = 0;
  21. string s = to_string(n);
  22. string nums = "01689";
  23. dfs("", s, nums, res);
  24. return res;
  25. }
  26.  
  27. void dfs(string t, string &s, string &nums, int &res) {
  28. if(t.size() > s.size() || t.size() == s.size() && t.compare(s) > 0) return;
  29. if(t.size() && t[0] == '0') return;
  30. string temp = t;
  31. reverse(temp.begin(), temp.end());
  32. for(int i=0; i<temp.size(); ++i) {
  33. if(temp[i] == '6') temp[i] = '9';
  34. else if(temp[i] == '9') temp[i] = '6';
  35. }
  36. if(t != temp) ++res;
  37. for(int i=0; i<nums.size(); ++i) {
  38. dfs(t + nums.substr(i, 1), s, nums, res);
  39. }
  40. }

No comments:

Post a Comment